#include "main.h"

#define APDS9960_i2c_TIMING           0xff410507
#define APDS9960_FLAG_TIMEOUT         ((uint32_t)0x1000)
#define APDS9960_LONG_TIMEOUT         ((uint32_t)(10 * APDS9960_FLAG_TIMEOUT))
__IO uint32_t  APDS9960_Timeout = APDS9960_LONG_TIMEOUT;



bool wireWriteDataByte(uint8_t reg, uint8_t val)
{
	IIC_Start(); 
	IIC_Send_Byte((APDS9960_I2C_ADDR<<1)|0);//ַ+д	
	if(IIC_Wait_Ack())	//ȴӦ
	{
		IIC_Stop();		 
		return false;		
	}
  IIC_Send_Byte(reg);	//дĴַ
  IIC_Wait_Ack();		//ȴӦ 
	IIC_Send_Byte(val);//
	if(IIC_Wait_Ack())	//ȴACK
	{
		IIC_Stop();	 
		return false;		 
	}		 
    IIC_Stop();	 
	return true; 			 
}


bool wireReadDataByte(uint8_t reg, uint8_t *val)	
{
	IIC_Start(); 
	IIC_Send_Byte((APDS9960_I2C_ADDR<<1)|0X00);//ַ+д	
	IIC_Wait_Ack();		//ȴӦ 
  IIC_Send_Byte(reg);	//дĴַ
  IIC_Wait_Ack();		//ȴӦ
  IIC_Start();
	IIC_Send_Byte((APDS9960_I2C_ADDR<<1)|0x01);//ַ+	
  IIC_Wait_Ack();		//ȴӦ 
	*val=IIC_Read_Byte(0);//ȡ,nACK 
  IIC_Stop();			//һֹͣ 
	return true;	
}

bool wireReadDataBlock(uint8_t reg,uint8_t *val,unsigned int len)
{
	unsigned char i = 0;
    IIC_Start(); 
    IIC_Send_Byte((APDS9960_I2C_ADDR<<1)|0);//ַ+д	
	  if(IIC_Wait_Ack())	//ȴӦ
	  {
		  IIC_Stop();		 
		  return -1;		
	  }
    IIC_Send_Byte(reg);	//дĴַ
    IIC_Wait_Ack();		//ȴӦ
    IIC_Start();
	  IIC_Send_Byte((APDS9960_I2C_ADDR<<1)|1);//ַ+	
    IIC_Wait_Ack();		//ȴӦ 
	  while(len)
	  {		 

//		  if(i >= len)    //ܼӣղ
//		  {
//        return -1;
//      }
		  if(len==1) val[i]=IIC_Read_Byte(0);//,nACK 
		  else val[i]=IIC_Read_Byte(1);		//,ACK 
		i++; 
		len--;
	  }  
    IIC_Stop();	//һֹͣ 
	  return i;
}
